.org $4000
#include "ti83plus.inc"
#include "SC/defs.z80"
#DEFINE APPNAME "CaDan A0"
#DEFINE APPPAGES 2
#include "SC/apphead.z80"
 jp ProgramStart
.dw fontbase

#DEFINE PAGE1
#include "SC/IM2.z80"
#DEFINE nexttextsys(xxxx) call RAND0293341 \ .dw xxxx
programstart:
 ld hl,Str0
 call PutS
 ld hl,appbackupscreen
 ld de,appbackupscreen+1
 ld bc,$02FF
 ld (hl),$00
 ldir
 ld hl,0
; set slowmode,h
 ld (mainflag),hl
 
;Creating temp file 
 ld hl,CaDanTemp
 rst 20h
 bcall(_ChkFindSym)
 bcallnc(_DelVarArc)
 ld hl,(1024*5)+16
 bcall(_EnoughMem)
 jp c,itNeverGotAChance
 ld hl,CaDanTemp
 rst 20h
 ld hl,1024*5
 bcall(_CreateProtProg)
 
;checking/verifying/creating scoring file. Need to do this LAST in filesys.
 ld hl,CaDanScore
 rst 20h
 bcall(_ChkFindSym)
 call c,InitScoreFile
 ld a,b
 or a
 jr z,$+5
 bcall(_Arc_Unarc)
 ld hl,CaDanScore
 rst 20h
 bcall(_ChkFindSym)
 ex de,hl
 ld c,(hl)
 inc hl
 ld b,(hl)
 inc hl
 ex de,hl
 ld hl,SCOREFILESIZE
 or a
 sbc hl,bc
 jp nz,RedoScoreFile   ;if filesize does not check out, then redo the file.
 ld hl,CaDanScoreHead
 ld b,7
 ld a,(de)
 cp (hl)
 inc de
 inc hl
 jp nz,RedoScoreFile   ;check if the fileheader is corrupted
 djnz $-7
 ld (scorestart),de
 
 ld hl,CaDantemp
 rst 20h
 bcall(_ChkFindSym)
 ld a,10
 ld ix,AppVarSpread
 ld hl,fontbase
InitTempAVar:
 ld c,(ix) \ inc ix
 ld b,(ix) \ inc ix
 ex de,hl
 add hl,bc
 ex de,hl
 ld (hl),e \ inc hl
 ld (hl),d \ inc hl
 dec a
 jr nz,InitTempAVar
 
 ld de,(fontbase)
 ld hl,CompressedText
 ld b,72
 call decomp
 ld hl,(fontbase)
 ld de,-192
 add hl,de
 ld (fontbase),hl
 
 ld hl,page_1
 in a,(6)
 ld (hl),a \ inc hl \ dec a
 ld (hl),a \ inc hl \ dec a
 ld (hl),a
 
 ld (stack),sp
 ld sp,newstack
  call enterGame  ;Portal to the Calculator Danmaku 83+ Engine/Game.
 ld sp,(stack)   ;Does not return to this section until it is fully done.
 ld hl,CaDanTemp
 rst 20h
 bcall(_ChkFindSym)   ;*must* exist since it entered the game.
 bcall(_DelVarArc)    ;Cleaning up temp prog while exiting.
 bcall($4C36)    ;reloadappentryvecs. Name is too long for TASM to swallow.
 ld hl,plotsscreen
 ld de,plotsscreen+1
 ld bc,$02FF
 ld (hl),$00
 ldir 
progstartcoll:
 bjump(_jforcecmdnochar)
itNeverGotAChance:
 ld hl,Str2
 call PutS
 bcall(_getkey)
 jr progstartcoll

RedoScoreFile:
 ld hl,CaDanScore
 rst 20h
 bcall(_ChkFindSym)   ;assumes it exists if it's here.
 bcall(_DelVarArc)
InitScoreFile:
 ld hl,SCOREFILESIZE+16
 bcall(_EnoughMem)
 jr c,itNeverGotAChance
 ld hl,CaDanScore
 rst 20h
 ld hl,SCOREFILESIZE
 bcall(_CreateAppvar)  ;scorestart
 inc de
 inc de
 ld hl,CaDanScoreHead
 ld bc,7
 ldir                   ;write out the file header
 ld (scorestart),de     ;where the data stream starts.
 ld bc,SCOREFILESIZE-(1+HEADERSIZE)
 ld h,d
 ld l,e
 inc de
 ld (hl),$00
 ldir         ;zeroes out the scorefile
 jr ResetScores
ResetScores:
 ld hl,(scorestart)
 ld de,GENSTATS+6   ;to jump over the placeholder bytes
 add hl,de
 ld ix,EasyScoreOffset+12
 ld a,4
ResettingScores:
 ld c,(ix+0)
 ld b,(ix+1)
 push af
  ld a,NUMPLAYERS
ClearTable:
  push hl
   push bc
    ld b,7
WriteTable:
    push bc
     ld de,DefaultScore
     ex de,hl
     ld bc,12
     ldir
     ex de,hl
    pop bc
    djnz WriteTable
   pop bc
  pop hl
  add hl,bc
  dec a
  jr nz,ClearTable
 pop af
 ld bc,14
 add ix,bc
 dec a
 jr nz,ResettingScores
 ret
 

PutS:
 ld a,(hl)
 inc hl
 or a
 ret z
 bcall(_PutC)
 jp PutS
Str0:
;    0123456789012345
.db " Please wait as "
.db " CaDan prepares "
.db " the game area. ",0
Str1:
.db "Not enough free "
.db "RAM. Press any  "
.db "key to exit game",0
Str2:
.db "The (pool|game) "
.db "is closed, due  "
.db "to AIDS. Press  "
.db "any key to GTFO.",0
CaDanTemp:
.db $05,"#CaDanTP"
CaDanScore:
.db $15,"cdSDAT00"
CaDanScoreHead:
.db $BB,$6D,$C9,"CaDa"
DefaultScore:
.db "Iambian ",$A0,$86,$01,$00

AppVarSpread:
.dw 2
.dw 576
.dw 128
.dw 80+80
.dw 128
.dw 64
.dw 80
.dw 512
.dw 512
.dw 2048
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
IOMemAddress:
.dw $843F-6
.dw 57+6
.dw $84BF
.dw 73
.dw $8588
.dw 356
.dw $89EC
.dw 78
.dw $8C4D
.dw $8F00-$8C4D

IOSaveLoad:
 ld ix,IOMemAddress
 ld hl,appbackupscreen+(767-(564-6))  ;reading address
 ld a,4
 call IOSaveLoad1
 ld hl,plotsscreen+(767-691)
 ld a,1
IOSaveLoad1:
 ld e,(ix+0)  ;write to address
 ld d,(ix+1)
 ld bc,4
 add ix,bc
 ld c,(ix-2)
 ld b,(ix-1)
 bit 0,(iy+0)  ;if not zero
 jr nz,$+8     ;Jump to WRITE out to memory locations
 ex de,hl
 ldir
 ex de,hl
 jr $+4
 ldir
 dec a
 jr nz,IOSaveLoad1
 ret

BackToTheStart:
 ld sp,(stackbase)
 jr InitTitleScreen
enterGame:
 di
 ld (storeiy),iy
 ld iy,myflag
 ld (stackbase),sp
;code to start point to interrupt 2 vector
 ld a,$41
 ld i,a
 im 2
;code to condition memory areas prior to use
 ld (iy+0),$00
 call IOSaveLoad
; ld hl,$8000
; ld de,$8001
; ld bc,$0EFF
; ld (hl),$00
; ldir
 ld a,%00001000  ;Acknowledge and disable
 out (3),a
 ld a,%00001010  ;Set 1st timer active
 out (3),a
 ld a,%00000110  ;Slowest frequency, ~110hz
 out (4),a

InitTitleScreen: .export InitTitleScreen
 xor a
 ld (iy+0),a
 ld (iy+1),a
 ld (iy+2),a
 set storymode,(iy+1)
 ld hl,StartTitleScreen   ;links to _menudat.z80
 ld (textsys),hl
 ei
 jp MasterLoop            ;infinite loop to allow interrupts to work

;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
exitGame:
 di
 set keyprimed,(iy+2)
 call getkeywait
; cpl
; or a
; jr z,$-5
 set 0,(iy+0)
 call IOSaveLoad
 ld iy,(storeiy)
 im 1
 ld sp,(stackbase)
 bcall($5011)                ;restores first 1087 bytes in RAM
 bcall(_DelRes)              ;invalidates statistic variables.
 ei
 ret
 
 
 
#include "SC/swap.z80"   ;code used to prep system between pageswaps
#include "SC/spells.z80" ;equates used to define score database structures
 
#include "S1/_textsys.z80"   ;text bitmap data and renderes
#include "S1/_menusys.z80"   ;menu commands and keypress routines
#include "S1/_menudat.z80"   ;menu "sprite" data
#include "S1/_chimdat.z80"   ;character image data for loading to appvar
#include "S1/_backers.z80"   ;background images and stuffs
#include "S1/_bossimg.z80"   ;images for teh bosses and stuffs
#include "S1/_story.z80"     ;Code to run boss/player dialogue.


.echo "\n"
.echo "CaDan Page 1 size: "
.echo $-$4000
.echo "\n"
.end