.org $4000
#DEFINE TESTMODE
#include "ti83plus.inc"
#include "SC/defs.z80"
;============================================
; Constant loads prior to $4100
.db 0      ;waste space to position B1Tab correctly with optimizations in place
B1Tab:
.db %11000000
.db %01100000
.db %00110000
.db %00011000
.db %00001100
.db %00000110
.db %00000011
.db %10000001
SprTab:
.db %11111111
.db %01111111
.db %00111111
.db %00011111
.db %00001111
.db %00000111
.db %00000011
.db %00000001
B2Tab:
.db %10000000
.db %01000000
.db %00100000
.db %00010000
.db %00001000
.db %00000100
.db %00000010
.db %00000001

DefaultBullet:    ;28+4=32
.dw DefaultBTD
.dw DefaultBTM
DefaultBullet2:
.dw DefaultBTD
.dw DefaultBTM
GSCTJpTbl:
.dw GSCTpMin
.dw GSCTnMin
.dw GSCTpMax
.dw GSCTnMax



DefaultBTD:
 ld hl,6
 add hl,sp
 ld sp,hl
 jp DrawEBTLoop
DefaultBTM:
 ld hl,6
 add hl,sp
 ld sp,hl
 jp MoveEBTLoop
DefaultPBT:
 pop af
 jp RunPBTLoop
DefaultENSP:
 pop af \ pop af
 jp DrawENSPLoop
XYJumpTable:
.dw ADD0XADD0Y
.dw ADD0XADD1Y
.dw ADD0XSUB1Y
.dw ADD0XSUB0Y
.dw ADD1XADD0Y
.dw ADD1XADD1Y
.dw ADD1XSUB1Y
.dw ADD1XSUB0Y
.dw SUB1XADD0Y
.dw SUB1XADD1Y
.dw SUB1XSUB1Y
.dw SUB1XSUB0Y
.dw SUB0XADD0Y
.dw SUB0XADD1Y
.dw SUB0XSUB1Y
.dw SUB0XSUB0Y

CDC_MOVEPATH:
.dw CDB_MP_NOMOVE     ;0
.dw CDB_MP_UPLEFT     ;1
.dw CDB_MP_UP         ;2
.dw CDB_MP_UPRIGHT    ;3
.dw CDB_MP_RIGHT      ;4
.dw CDB_MP_DOWNRIGHT  ;5
.dw CDB_MP_DOWN       ;6
.dw CDB_MP_DOWNLEFT   ;7
.dw CDB_MP_LEFT       ;8
.dw CDB_MP_MOVETOPX   ;9
.dw CDB_MP_MOVETOPY   ;10
.dw CDB_MP_DEFAULT1   ;11
.dw CDB_MP_DEFAULT2   ;12
.dw CDB_MP_           ;13
.dw CDB_MP_           ;14
.dw CDB_MP_EOF        ;15  
 
BType01Shot2:
.dw DrawB1  ;uh...
.dw MoveB2  ;circular bullet movement. Requires that helper table installed.
.dw DefaultBTD
.dw ReturnToDust
BType01Shot2R:
.dw DrawB1
.dw MoveB2R ;circular with "right" movement. Clockwise.
.dw DefaultBTD
.dw ReturnToDust
BType01Shot2L:
.dw DrawB1
.dw MoveB2L ;circular with "left" movement. Counter clockwise.
.dw DefaultBTD
.dw ReturnToDust
BT01DthR:
.dw DrawB1
.dw MoveB2R
.dw DrawB1
.dw ExpireAt10
.dw DrawB2
.dw MoveB2R
.dw DefaultBTD
.dw ReturnToDust
BT01DthL:
.dw DrawB1
.dw MoveB2L
.dw DrawB1
.dw ExpireAt10
.dw DrawB2
.dw MoveB2L
.dw DefaultBTD
.dw ReturnToDust

DrawLine:     ;totally a phase disrupt thing.
.dw DefaultBTD
.dw LineDrawPhaseNo
.dw LineDrawPhase0
.dw LineDrawPhase1
.dw LineDrawPhase2
.dw LineDrawPhase3
.dw LineDrawPhase4
.dw LineDrawPhase5
.dw DefaultBTD
.dw ReturnToDust


.echo "\n"
.echo "SPARE : "
.echo $4100-$
.echo "\n"

;====================================
 

#DEFINE PAGE2
#include "SC/IM2.z80"
programstart:





#include "SC/swap.z80"

#include "S2/_bullets.z80"   ; Engine component for bullet render/movement
#include "S2/_drawlcd.z80"   ; Routines to render material to the LCD.
#include "S2/_movdraw.z80"   ; Sprite movement, drawing and script commanding
#include "S2/_splcard.z80"   ; Spellcard rendering and stuffs
#include "S2/_taskers.z80"   ; Tasks for the system.
#include "S2/_runcode.z80"   ; The system used to run the scripts
#include "S2/_script2.z80"   ; All the scripts in the game
#include "S2/_chardat.z80"
#include "temp.exp"          ; Export file for stuffs.
.echo "\n"
.echo "CaDan Page 2 size: "
.echo $-$4000
.echo "\n"

.end